C      Demonstration program for PLplot: Bar chart example.
      implicit none

      character*20 string
      integer i
      real*8 y0(10)

      call plinit()

      call pladv(0)
      call plvsta
      call plwind( 1980.d0, 1990.d0, 0.d0, 35.d0 )
      call plbox( 'bc', 1.d0, 0, 'bcnv', 10.d0, 0 )
      call plcol0(2)
      call pllab( 'Year', 'Widget Sales (millions)',
     &            '#frPLplot Example 12' )

      y0(1) = 5
      y0(2) = 15
      y0(3) = 12
      y0(4) = 24
      y0(5) = 28
      y0(6) = 30
      y0(7) = 20
      y0(8) = 8
      y0(9) = 12
      y0(10) = 3

      do i = 0, 9
        call plcol0(i + 1)
        call plpsty(0)
        call plfbox( dble (1980.d0+i), y0(i+1) )
        write (string, '(i8)')int(y0(i+1))
        call lalign(string)
        call plptex( dble (1980.d0+i+0.5d0), y0(i+1)+1.d0,
     &    1.d0, 0.d0, 0.5d0, string )
        write (string, '(i8)')1980+i
        call lalign(string)
        call plmtex( 'b', 1.d0, dble ((i+1)*0.1d0-0.05d0),
     &    0.5d0, string )
      enddo

C      Don't forget to call PLEND to finish off!
      call plend
      end

C      Suck up leading spaces

      subroutine lalign(string)
      implicit none
      integer i, j, k, max, len
      character*(*) string

      max = len(string)

      do i = 1, max
        if (string(i:i) .ne. ' ') then
          if (i .eq. 1) return
          k = 1
          do j = i, max
            string(k:k) = string(j:j)
            k = k + 1
          enddo
          do j = k, max
            string(j:j) = ' '
          enddo
          return
        endif
      enddo
      end

      subroutine plfbox(x0, y0)
      implicit none

      real*8 x0, y0, x(4), y(4)

      x(1) = x0
      y(1) = 0.d0
      x(2) = x0
      y(2) = y0
      x(3) = x0+1.d0
      y(3) = y0
      x(4) = x0+1.d0
      y(4) = 0.d0
      call plfill( 4, x, y )
      call plcol0(1)
      call pllsty(1)
      call plline( 4, x, y )
      end
